package org.vamsas.client.picking;

import java.io.*;
import java.net.*;

class PickEndPoint extends Thread
{
	private Socket socket;
	private BufferedWriter os;
	private BufferedReader in;
	
	// Constructs a new client connection (client->server)
	PickEndPoint()
		throws Exception
	{
		// Attempt to connect...
		// If we fail, wrapper has to attempt to make server instead??
		// Or keep trying until a server exists
		socket = new Socket(InetAddress.getLocalHost(), PickServer.PORT);
		
		createStreams();
	}
	
	// Constructs a new client based on an existing connection (server->client)
	PickEndPoint(Socket s)
		throws IOException
	{
		socket = s;
		createStreams();
	}
	
	private void createStreams()
		throws IOException
	{
		os = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));
		
		in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
		
		start();
	}
	
	void send()
	{
		try
		{
			System.out.println("CLIENT: sending message...");
			os.write("test message: " + (System.currentTimeMillis()));
			
			// We use a newline to terminate the message
			os.newLine();
			os.flush();
			System.out.println("CLIENT: message sent");
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
	}
	
	public void run()
	{
		try {
		while (true)
		{
			String str = in.readLine();
			
			System.out.println("CLIENT: READ: " + str);
		}
	}
	catch (Exception e)
	{
		System.out.println("CLIENT: read fail: " + e);
		// Means the other end of the connection has (probably died) so we need
		// terminate this endpoint (if this is server side)
	}
	}
}